package blockBreaker.template;

import java.applet.Applet;
import java.awt.Graphics;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

/**
 * 
 * @author あなたのお名前
 * 
 */
@SuppressWarnings("serial")
public class Main extends Applet implements KeyListener, Runnable{

	/*-----オブジェクト関連のフィールド-----*/
	private Ball ball;
	private Bar bar;
	private Block[][] stage;
	private Thread repaintThread;
	/*-----オブジェクト関連のフィールド-----*/
	
	
	/*-----フラグ関連のフィールド-----*/
	/** 現在、左矢印キーが押されているかどうかのフラグ */
	private boolean leftKeyFlag = false;
	/** 現在、右矢印キーが押されているかどうかのフラグ */
	private boolean rightKeyFlag = false;
	/*-----フラグ関連のフィールド-----*/
	
	
	/*-----シーン制御関連のフィールド-----*/
	/**
	 * 現在、どのシーンかを表す<br>
	 * 0:初期画面<br>
	 * 1:プレイ中画面<br>
	 * 2:ゲームクリア画面
	 * 3:ゲームオーバー画面<br>
	 */
	private int scene = 0;
	/*-----シーン制御関連のフィールド-----*/
	
	
	/*-----Appletから継承したメソッド-----*/
	@Override
	public void init(){
		/* 
		 * 初期化処理を記述する
		 * ・画面サイズsetSize(~);
		 * ・背景色setBackground(~);
		 */
	}
	@Override
	public void paint(Graphics g){
		switch(scene){
		case 0:
			ready(g);//初期画面
			break;
		case 1:
			playing(g);//プレイ中画面
			break;
		case 2:
			gameclear(g);//ゲームクリア画面
			break;
		case 3:
			gameover(g);//ゲームオーバー画面
			break;
		}
	}
	
	/*-----Appletから継承したメソッド-----*/
	
	/*-----Runnableから継承したメソッド-----*/
	@Override
	public void run() {
		//一定間隔ごとにrepaint()を呼び出す処理を記述		
	}
	/*-----Runnableから継承したメソッド-----*/
	
	
	/*-----KeyListenerから継承したメソッド-----*/
	@Override
	public void keyPressed(KeyEvent e) {
		/*
		 * いずれかのキーが押されている場合、呼び出される。
		 * 変数eからどのキーが押されているかを判定する
		 */
	}

	@Override
	public void keyReleased(KeyEvent e) {
		/*
		 * いずれかのキーが離された場合、呼び出される。
		 * 変数eからどのキーが離されたかを判定する
		 */
	}

	@Override
	public void keyTyped(KeyEvent e) {
		//今回は使用しない
	}
	/*-----KeyListenerから継承したメソッド-----*/
	
	
	/*-----シーン制御関連のメソッド-----*/
	private void ready(Graphics g){
		//ゲーム開始画面を描画する
	}
	private void playing(Graphics g){
		//ゲームプレイ中の画面を描画する
	}
	private void gameclear(Graphics g){
		//ゲームクリア画面を描画する
	}
	private void gameover(Graphics g){
		//ゲームオーバー画面を描画する
	}
	/*-----シーン制御関連のメソッド-----*/

}
